unit Degradeur;

interface
Uses Windows,Forms,Graphics;

Type
    TDegradeClass = Class
      Private
        FStartColor : TColor;{ Couleur de dpart pour le dgrad }
        FCurColor   : TColor;{ Couleur Courante }
        FEndColor   : TColor;{ Couleur  atteindre pour le dgrad }

        FStartRGB   : Array[0..2] of Byte; { RGB de la couleur de dpart }
        FCurrentRGB : Array[0..2] of Byte; { RGB de la couleur courante }
        FDeltaRGB   : Array[0..2] of Integer; { RGB  ajouter  la couleur de
                                             dpart pour atteindre la couleur
                                             de fin }
      Public
        Constructor Create;
        Destructor Destroy;Override;

        Procedure Graduate(AForm:TForm;AStartColor,AEndColor:TColor);
      End;

implementation

Procedure TDegradeClass.Graduate(AForm:TForm;AStartColor,AEndColor:TColor);
Var
   aBand : TRect; { Bande rectangulaire de couleur courante }
   i     : Integer; { Compteur pour parcourir la hauteur de la fiche }
Begin
{ Calcul des valeurs RGB pour la couleur courante }
FStartRGB[0] := GetRValue( ColorToRGB( AStartColor ) );
FStartRGB[1] := GetGValue( ColorToRGB( AStartColor ) );
FStartRGB[2] := GetBValue( ColorToRGB( AStartColor ) );
{ Calcul des valeurs  ajouter pour atteindre la couleur de fin }
FDeltaRGB[0] := GetRValue( ColorToRGB( AEndColor )) - FStartRGB[0];
FDeltaRGB[1] := GetgValue( ColorToRGB( AEndColor )) - FStartRGB[1];
FDeltaRGB[2] := GetbValue( ColorToRGB( AEndColor )) - FStartRGB[2];

{ Initialisation des dimensions de la bande de couleur }
aBand.Left :=0;
aBand.Right:=AForm.ClientWidth;
{ Boucle pour remplir la fiche courante en dgrad }
AForm.Canvas.Pen.Style:=psSolid;
AForm.Canvas.Pen.Mode:=pmCopy;
For i:= 0 To 255
Do Begin
   { Dimensions verticales de la bande }
   aBand.Top := MulDiv( i , AForm.ClientHeight , 256 );
   aBand.Bottom := MulDiv( i+1 , AForm.ClientHeight , 256 );
   { Calcul de la couleur courante }
   FCurrentRGB[0] := (FStartRGB[0] + MulDiv( i , FDeltaRGB[0] , 255 )) mod 256;
   FCurrentRGB[1] := (FStartRGB[1] + MulDiv( i , FDeltaRGB[1] , 255 )) mod 256;
   FCurrentRGB[2] := (FStartRGB[2] + MulDiv( i , FDeltaRGB[2] , 255 )) mod 256;
   { Affichage sur la fiche }
   With AForm.Canvas
   Do Begin
      Brush.color:=RGB(FCurrentRGB[0],FCurrentRGB[1],FCurrentRGB[2]);
      FillRect(aBand);
      End;
   End;
End;

Constructor TDegradeClass.Create;
Begin
Inherited Create;
End;

Destructor TDegradeClass.Destroy;
Begin
Inherited Destroy;
End;
end.
