unit disp_coordinance;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Grids, Buttons, math;

type
  Tfdisp_coordinance = class(TForm)
    BitBtn1: TBitBtn;
    Label4: TLabel;
    Edit1: TEdit;
    SpeedButton1: TSpeedButton;
    Label2: TLabel;
    Memo1: TMemo;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    procedure initialise(Sender: TObject);
    procedure sortie(Sender: TObject);
    procedure calcule(Sender: TObject);
    procedure creation(Sender: TObject);
    procedure keypressed(Sender: TObject; var Key: Char);
    procedure edit_liste(Sender: TObject);
    procedure FormDeactivate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  fdisp_coordinance: Tfdisp_coordinance;

implementation
uses
  oemath,digicode;

{$R *.DFM}

procedure Tfdisp_coordinance.initialise(Sender: TObject);
//------------------------------------------------------
var
  s,s1,atome_central                 :string;

begin
  atome_central:=child[no_atome_coordinance].nom;
  traite_nom_atome(atome_central);
  memo1.clear;
  x_coordinance:=xstk[no_atome_coordinance];
  y_coordinance:=ystk[no_atome_coordinance];
  z_coordinance:=zstk[no_atome_coordinance];
  s:='Distances and angles around the atom '+atome_central;
  (*str(x_coordinance:8:4,s1);s:=s+' ('+s1;
  str(y_coordinance:8:4,s1);s:=s+s1;
  str(z_coordinance:8:4,s1);s:=s+s1+')'; *)
  str(child[no_atome_coordinance].x:8:4,s1);s:=s+' ('+s1;
  str(child[no_atome_coordinance].y:8:4,s1);s:=s+s1;
  str(child[no_atome_coordinance].z:8:4,s1);s:=s+s1+')';
  caption:=s;
  edit1.setfocus;
end;

procedure Tfdisp_coordinance.sortie(Sender: TObject);
//--------------------------------------------------
begin
  if fileexists('envir.txt') then deletefile('envir.txt');
  fdisp_coordinance.visible:=false;
  flag_coordinance:=0;
end;

procedure Tfdisp_coordinance.calcule(Sender: TObject);
//----------------------------------------------------
var
  s,s1,s2,si,sj                                  : string;
  c4i,c4j                                        : string[4];
  atome_central                                  : string;
  i,j,k,ier,nb_atomes,i1,i2,i3,i4                : integer;
  d1,d2,x1,x2,y1,y2,z1,z2,angle,arg              : double;
  at_lies                                        : array[1..100] of atomes;
  xlstk,ylstk,zlstk                              : array[1..100] of double;
  nb_at_lies                                     : integer;
  nomf                                           : TextFile;
begin
  nb_atomes:=0;
  s:=child[no_atome_coordinance].nom;
  traite_nom_atome(s);
  atome_central:=s;
  memo1.clear;
  //memo2.clear;
  s:='                Linked atoms';
  memo1.Lines[0]:=s;
  s:=edit1.text;
  val(s,rayon_coordinance,ier);
  if (ier > 0)then begin
    erreur('Read error');
    edit1.setfocus;
    beep;
    exit;
  end;
//Calcul
  assignFile(nomf,repertoire_origine+'/envir.txt');
  rewrite(nomf);
  if (nom_fichier_grt <> '') then writeln(nomf,extractFilename(nom_fichier_grt))
  else writeln(nomf,extractFilename(nom_fichier_shelx));
  s:=uppercase(child[no_atome_coordinance].element);
  if (s = 'DU')then begin
    i1:=0;
    i2:=0;
    i3:=0;
    i4:=0;
  end else
    code_positions(no_atome_coordinance,i1,i2,i3,i4);

  with child[no_atome_coordinance] do begin
    //code_positions(no_atome_coordinance,i1,i2,i3,i4);
    writeln(nomf,'Linked atoms with ',nom:4,x:10:5,y:10:5,z:10:5,
    '  (',s_pos[i1],') (',i2,i3,i4,')');
  end;
  nb_at_lies:=0;
  for i:=1 to nb_child do begin
    d1:=0;
    d1:=sqrt(sqr(x_coordinance-xstk[i])+sqr(y_coordinance-ystk[i])+
    sqr(z_coordinance-zstk[i]));
    if (d1 > 0.0001) and  (d1 <= rayon_coordinance)then begin
      nb_at_lies:=nb_at_lies+1;
      at_lies[nb_at_lies]:=child[i];
      si:='(';str(nb_at_lies:3,s1);si:=si+s1+')';
      xlstk[nb_at_lies]:=xstk[i];
      ylstk[nb_at_lies]:=ystk[i];
      zlstk[nb_at_lies]:=zstk[i];
      with child[i] do begin
        s:=si;
        s1:=nom;
        traite_nom_atome(s1);
        c4i:=copy(s1,1,4);
        if (length(c4i) < 4)then for k:=length(c4i)+1 to 4 do c4i:=c4i+' ';
        s:=s+c4i;
        str(x:8:4,s1);
        s:=s+s1;
        str(y:8:4,s1);
        s:=s+s1;
        str(z:8:4,s1);
        s:=s+s1;
      end;
      str(d1:6:3,s1);
      s:=s+' d='+s1;
      s2:=uppercase(child[i].element);
      if (s2 = 'DU')then begin
        i1:=0;
        i2:=0;
        i3:=0;
        i4:=0;
      end else
        code_positions(i,i1,i2,i3,i4);
      s:=s+' ('+s_pos[i1]+') ('+inttostr(i1)+'_'+inttostr(i2)+inttostr(i3)+inttostr(i4)+')';
      memo1.lines.add(s);
      writeln(nomf,s);
    end;
  end;

  s:='            Angles';
  memo1.Lines.add(s);
  with child[no_atome_coordinance] do begin
    writeln(nomf,'Angles around ',nom:4,x:10:5,y:10:5,z:10:5);
  end;
  for i:=1 to nb_at_lies-1 do begin
    si:='(';str(i:3,s1);si:=si+s1+')';
    d1:=sqrt(sqr(x_coordinance-xlstk[i])+sqr(y_coordinance-ylstk[i])+
    sqr(z_coordinance-zlstk[i]));
    if (d1 > 0.0001) and  (d1 <= rayon_coordinance)then begin
      s:=si;
      s1:=at_lies[i].nom;traite_nom_atome(s1);c4i:=copy(s1,1,4);
      if (length(c4i) < 4)then for k:=length(c4i)+1 to 4 do c4i:=c4i+' ';
      for j:=i+1 to nb_at_lies do begin
        s1:=at_lies[j].nom;traite_nom_atome(s1);c4j:=copy(s1,1,4);
        if (length(c4j) < 4)then for k:=length(c4j)+1 to 4 do c4j:=c4j+' ';
        sj:='(';str(j:3,s1);sj:=sj+s1+')';
        d2:=0;
        d2:=sqrt(sqr(x_coordinance-xlstk[j])+sqr(y_coordinance-ylstk[j])+
        sqr(z_coordinance-zlstk[j]));
        if (d2 > 0.001) and (d2 <= rayon_coordinance)then begin
          x1:=x_coordinance-xlstk[i];
          y1:=y_coordinance-ylstk[i];
          z1:=z_coordinance-zlstk[i];
          x2:=x_coordinance-xlstk[j];
          y2:=y_coordinance-ylstk[j];
          z2:=z_coordinance-zlstk[j];
          arg:=(x1*x2+y1*y2+z1*z2)/(d1*d2);
          if (abs(arg) > 1) then arg:=arg/abs(arg);
          angle:=57.2957*arccos(arg) ;
          s:=c4i+si+'-'+atome_central+'-'+c4j+sj+' a=';
          str(angle:7:2,s1);
          s:=s+s1;
          memo1.lines.add(s);
          writeln(nomf,s);
        end;
      end;
    end;
  end;
  closefile(nomf);
end;

procedure Tfdisp_coordinance.creation(Sender: TObject);
//------------------------------------------------------
begin
  left:=460;
  top:=0;
end;

procedure Tfdisp_coordinance.keypressed(Sender: TObject; var Key: Char);
//----------------------------------------------------------------------
begin
  if (ord(key)  =13)then calcule(Sender);
end;

procedure Tfdisp_coordinance.edit_liste(Sender: TObject);
//-------------------------------------------------------
var
   CmdFile           : PChar;
   i                 : integer;
begin
  CmdFile:='write.exe envir.txt';
  i:=WinExec(CmdFile,5);
end;

//Dsactivation
procedure Tfdisp_coordinance.FormDeactivate(Sender: TObject);
//-----------------------------------------------------------
begin
  if fileexists('envir.txt') then deletefile('envir.txt');
  fdisp_coordinance.visible:=false;
  flag_coordinance:=0;
  close;
end;

end.
