unit efface;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls, Grids, ColorBtns;

type
  Tfefface = class(TForm)
    Panel1: TPanel;
    Panel4: TPanel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    StringGrid1: TStringGrid;
    Label1: TLabel;
    Memo1: TMemo;
    Panel3: TPanel;
    StringGrid2: TStringGrid;
    Label3: TLabel;
    Memo3: TMemo;
    Memo2: TMemo;
    RadioGroup1: TRadioGroup;
    Color95Button1: TColor95Button;
    Color95Button2: TColor95Button;
    Color95Button3: TColor95Button;
    Color95Button4: TColor95Button;
    procedure initialise(Sender: TObject);
    procedure Sortie(Sender: TObject);
    procedure selecte_elem_todel(Sender: TObject; Col, Row: Integer;
      var CanSelect: Boolean);
    procedure del_elem_system(Sender: TObject);
    procedure peint_stringgrid1(Sender: TObject; Col, Row: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure peint_stringgrid2(Sender: TObject; Col, Row: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure select_at_todel(Sender: TObject; Col, Row: Integer;
      var CanSelect: Boolean);
    procedure del_atom_system(Sender: TObject);
    procedure onclic(Sender: TObject);
    procedure onclic2(Sender: TObject);
    procedure efface_bloc(Sender: TObject);
    procedure choix_mode_del(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  fefface: Tfefface;

implementation

{$R *.DFM}

uses
  oemath,at_motif;
var
  type_effacement                 : integer;
  arow1,acol1,arow2,acol2         : integer;

procedure Tfefface.initialise(Sender: TObject);
//---------------------------------------------
var
   i                 : integer;
   s3                : string[3];
begin
  fefface.left:=600;fefface.top:=52;fefface.width:=307;
  panel1.left:=150;
  panel1.top:=8;
  panel3.left:=150;
  panel3.top:=8;
  panel4.left:=150;
  panel4.top:=8;

  with stringgrid1 do begin
   rowcount:=nb_typ_element+2;
   height:=21*rowcount;
   if(height > 425)then height:=425;
   for i:=0 to rowcount-1 do begin
       cells[0,i]:='';
       cells[1,i]:='';
    end;
    cells[0,0]:='Nb';
    cells[1,0]:='Elem.';
    cells[2,0]:='Sel.';
    for i:=1 to nb_typ_element do cells[0,i]:=element[i].nom;
  end;
  with stringgrid2 do begin
    rowcount:=nb_motif+2;
    for i:=0 to rowcount-1 do begin
       cells[0,i]:='';
       cells[1,i]:='';
    end;
    cells[0,0]:='Nb';
    cells[1,0]:='Atom';
    for i:=1 to nb_motif do begin
       cells[0,i]:=inttostr(i);
       cells[1,i]:=motif[i].nom;
    end;
  end;
end;

procedure Tfefface.Sortie(Sender: TObject);
//----------------------------------------
begin
  close;
end;

procedure ecrit_stringGrid2;
//-------------------------
var
    i,j         : integer;
    s           : string;
    x           : real;
begin
   with fmotif.stringGrid2 do begin
     refresh;
     colwidths[0]:=27;
     colwidths[1]:=37;
     rowCount:=nb_motif+1;
     cells[0,0]:=' No';
     cells[1,0]:='Atome';
     cells[2,0]:='     X';
     cells[3,0]:='     Y';
     cells[4,0]:='     Z';
     cells[5,0]:='     B11';
     cells[6,0]:='     B22';
     cells[7,0]:='     B33';
     cells[8,0]:='     B12';
     cells[9,0]:='     B13';
     cells[10,0]:='     B23';
     for i:=1 to nb_motif do begin
       cells[0,i]:=inttostr(i);
       cells[1,i]:=motif[i].nom;
       str(motif[i].x:9:5,s);
       cells[2,i]:=s;
       str(motif[i].y:9:5,s);
       cells[3,i]:=s;
       str(motif[i].z:9:5,s);
       cells[4,i]:=s;
       for j:=1 to 6 do begin
         if (abs(motif[i].beta[j]) <  0.000001)then begin
           s:='';
         end else begin
           str(motif[i].beta[j]:9:6,s);
           cells[4+j,i]:=s;
         end;
       end;
     end;
   end;
end;

procedure Tfefface.selecte_elem_todel(Sender: TObject; Col, Row: Integer;
  var CanSelect: Boolean);
//-----------------------------------------------------------------------
begin
  arow1:=row;
  acol1:=col;
end;

procedure Tfefface.del_elem_system(Sender: TObject);
//------------------------------------------------
var
  s                    : string;
  s2                   : string[2];
  i,j,k,ier,n          : integer;

  atdel                : array [1..200] of ^atomes;
  elem_to_del          : array[1..10] of string[2];
  nb_to_del            : integer;
  w                    : word;
begin
  //Message
  beep;
  s:='Are you sure to want to delete systematicaly the selected types of atom?';
  w:=messageDlg(s,mtConfirmation,mbYesNoCancel,0);
  if (w = mrNo) or (w = mrAbort) then exit;

  //Slection des lements  effacer
  nb_to_del:=0;
  with stringGrid1 do begin
    n:=nb_typ_element;
    for i:=1 to n do begin
      s:=cells[0,i];
      if (pos('*',s) = 0) then continue else delete(s,pos('*',s),1);
      s:=trim(s);
      ier:=0;
      nb_to_del:=nb_to_del+1;
      elem_to_del[nb_to_del]:=s;
      for j:= 1 to nb_typ_element do begin
        if (s = element[j].nom) then begin
          ier:=j;
          break;
        end;
      end;
      if (ier > 0)then begin
        if (ier < nb_typ_element)then
        for j:=ier+1 to nb_typ_element do element[j-1]:=element[j];
        nb_typ_element:=nb_typ_element-1;
      end;
    end;
  end;

  //Remise  jour de la liste des lments
(*  n:=nb_typ_element;
  for i:=1 to n do begin
    if (i > nb_typ_element)then break;
    for j:=1 to nb_to_del do begin
      if (elem_to_del[j] = element[i].nom)then begin
         if (i < nb_typ_element)then
           for k:=i to nb_typ_element-1 do element[k]:=element[k+1];
         nb_typ_element:=nb_typ_element-1;
         break;
      end;
    end;
  end; *)


  //Effacement des atomes du motif
  n:=nb_motif;
  for i:=1 to nb_to_del do begin
    for j:=1 to nb_motif do begin
      s:=copy(motif[j].nom,1,2);
      traite_nom_element(s);
      s2:=trim(s);s2:=uppercase(s2);
      if (s2 = elem_to_del[i])then motif[j].nom:='';
    end;
  end;
  n:=0;
  for i:=1 to nb_motif do begin
    if (motif[i].nom <> '')then begin
      n:=n+1;
      new(atdel[n]);
      atdel[n]^:=motif[i];
    end;
  end;
  for i:=1 to n do motif[i]:=atdel[i]^ ;
  for i:=1 to n do dispose(atdel[i]);
  nb_motif:=n;
  set_typ_liaisons;
  initialise(sender);
  fmotif.affichage(sender);
  panel1.visible:=false;
end;

procedure Tfefface.peint_stringgrid1(Sender: TObject; Col, Row: Integer;
  Rect: TRect; State: TGridDrawState);
//-----------------------------------------------------------------------
var
  s        : string;
  posx,i   : integer;
begin
  s:=trim(StringGrid1.cells[col,row]);
  if (pos('*',s) > 0) then begin
    stringgrid1.canvas.brush.color:=$EECBFF;
    stringgrid1.canvas.fillrect(rect);
    stringgrid1.canvas.font.color:=clblack;
    stringgrid1.canvas.textout(rect.left+2,rect.top+2,stringgrid1.cells[col,row]);
  end ;
  //s:=stringgrid1.cells[col,row];
  posx:= ((Rect.right-rect.left-2)-stringgrid1.canvas.textWidth(s)) div 2;
  stringgrid1.canvas.textrect(rect,rect.left+posx,rect.top,s);
 end;

procedure Tfefface.peint_stringgrid2(Sender: TObject; Col, Row: Integer;
  Rect: TRect; State: TGridDrawState);
//---------------------------------------------------------------------
var
  s        : string;
  posx,i   : integer;
begin
  s:=trim(stringGrid2.cells[1,row]);
  if (pos('*',s) > 0) and (col = 1) then begin
    stringGrid2.canvas.brush.color:=$EECBFF;
    stringGrid2.canvas.fillrect(rect);
    stringGrid2.canvas.font.color:=clblack;
    stringGrid2.canvas.textout(rect.left+2,rect.top+2,stringGrid2.cells[col,row]);
  end;
  s:=stringGrid2.cells[col,row];
  posx:= ((Rect.right-rect.left-2)-stringGrid2.canvas.textWidth(s)) div 2;
  stringGrid2.canvas.textrect(rect,rect.left+posx,rect.top,s);
end;

procedure Tfefface.select_at_todel(Sender: TObject; Col, Row: Integer;
  var CanSelect: Boolean);
//--------------------------------------------------------------------
begin
  if (col = 1)then begin
    arow2:=row;
    acol2:=col;
  end;
end;

procedure Tfefface.del_atom_system(Sender: TObject);
//--------------------------------------------------
var
  atdel                : array [1..200] of ^atomes;
  i,n                  : integer;
  s                    : string;
  w                    : word;
begin
  //Message
  beep;
  s:='Are you sure to want to delete the selected atoms ?';
  w:=messageDlg(s,mtConfirmation,mbYesNoCancel,0);
  if (w = mrNo) or (w = mrAbort) then exit;

  n:=0;
  for i:=1 to nb_motif do begin
    s:=stringgrid2.cells[1,i];
    if (pos('*',s) > 0) then continue;
    n:=n+1;
    new(atdel[n]);
    atdel[n]^:=motif[i];
  end;
  for i:=1 to n do motif[i]:=atdel[i]^ ;
  for i:=1 to n do dispose(atdel[i]);
  nb_motif:=n;
  panel3.visible:=false;
  fmotif.affichage(sender);
  initialise(sender);
end;

procedure Tfefface.onclic(Sender: TObject);
//----------------------------------------
var s:string;
begin
  s:=stringGrid1.cells[acol1,arow1];
  if (pos('*',s) > 0) then delete (s,pos('*',s),1)
  else s:=s+'*';
  stringGrid1.cells[acol1,arow1]:=s;
end;

procedure Tfefface.onclic2(Sender: TObject);
var s:string;
begin
  if (acol2 = 1)then begin
    s:=stringGrid2.cells[1,arow2];
    if (pos('*',s) > 0) then delete(s,pos('*',s),1)
    else s:=s+'*';
    stringGrid2.cells[1,arow2]:=s;
  end;
end;

procedure Tfefface.efface_bloc(Sender: TObject);
//---------------------------------------------
var
  atdel                           : array [1..200] of ^atomes;
  i,n                             : integer;
  s                               : string;
  deb_effacement,fin_effacement   : integer;
  w                               : word;
begin

  s:=edit1.text;
  deb_effacement:=strtoint(s);
  s:=edit2.text;
  fin_effacement:=strtoint(s);

  //Message
  beep;
  s:='Are you sure to want to delete the atoms '+inttostr(deb_effacement)+' to '+
  inttostr(fin_effacement)+' ?';
  w:=messageDlg(s,mtConfirmation,mbYesNoCancel,0);
  if (w = mrNo) or (w = mrAbort) then exit;

  n:=0;
  for i:=1 to deb_effacement-1 do begin
    s:=stringgrid2.cells[1,i];
    if (pos('*',s) > 0) then continue;
    n:=n+1;
    new(atdel[n]);
    atdel[n]^:=motif[i];
  end;
  for i:=fin_effacement+1 to nb_motif do begin
    s:=stringgrid2.cells[1,i];
    if (pos('*',s) > 0) then continue;
    n:=n+1;
    new(atdel[n]);
    atdel[n]^:=motif[i];
  end;
  for i:=1 to n do motif[i]:=atdel[i]^ ;
  for i:=1 to n do dispose(atdel[i]);
  edit1.text:='';
  edit2.text:='';
  nb_motif:=n;
  panel4.visible:=false;
  fmotif.affichage(sender);
  initialise(sender);
end;


procedure Tfefface.choix_mode_del(Sender: TObject);
//-----------------------------------------------
begin
  case RadioGroup1.ItemIndex of
    0: begin
         if panel3.visible then panel3.visible:=false;
         if panel4.visible then panel4.visible:=false;
         panel1.visible:=true;
       end;
    1: begin
         if panel1.visible then panel1.visible:=false;
         if panel4.visible then panel4.visible:=false;
         panel3.visible:=true;
       end;
    2: begin
         if panel1.visible then panel1.visible:=false;
         if panel3.visible then panel3.visible:=false;
         panel4.visible:=true;
       end;
  end;
end;


end.
