unit effaceA;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Grids, ColorBtns, ExtCtrls;

type
  TfeffaceA = class(TForm)
    Panel3: TPanel;
    Color95Button3: TColor95Button;
    StringGrid2: TStringGrid;
    Memo3: TMemo;
    procedure peint_stringgrid2(Sender: TObject; Col, Row: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure initialise(Sender: TObject);
    procedure onclic(Sender: TObject);
    procedure select_atom_to_del(Sender: TObject; Col, Row: Integer;
      var CanSelect: Boolean);
    procedure del_atom(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  feffaceA: TfeffaceA;

implementation

{$R *.DFM}

uses
  oemath,paneau1;
var
  arow2,acol2         : integer;

procedure TfeffaceA.peint_stringgrid2(Sender: TObject; Col, Row: Integer;
  Rect: TRect; State: TGridDrawState);
//------------------------------------------------------------------------
var
  s        : string;
  posx     : integer;
begin
  s:=trim(stringGrid2.cells[1,row]);
  if (pos('*',s) > 0) and (col = 1) then begin
    stringGrid2.canvas.brush.color:=$EECBFF;
    stringGrid2.canvas.fillrect(rect);
    stringGrid2.canvas.font.color:=clblack;
    stringGrid2.canvas.textout(rect.left+2,rect.top+2,stringGrid2.cells[col,row]);
  end;
  s:=stringGrid2.cells[col,row];
  posx:= ((Rect.right-rect.left-2)-stringGrid2.canvas.textWidth(s)) div 2;
  stringGrid2.canvas.textrect(rect,rect.left+posx,rect.top,s);
end;

procedure TfeffaceA.initialise(Sender: TObject);
//---------------------------------------------
var
   i                 : integer;
   //s3                : string[3];
begin
   with stringgrid2 do begin
    rowcount:=nb_motif+2;
    for i:=0 to rowcount-1 do begin
       cells[0,i]:='';
       cells[1,i]:='';
    end;
    cells[0,0]:='Nb';
    cells[1,0]:='Atom';
    for i:=1 to nb_motif do begin
       cells[0,i]:=inttostr(i);
       cells[1,i]:=motif[i].nom;
    end;
  end;
end;

procedure TfeffaceA.onclic(Sender: TObject);
//------------------------------------------
var s:string;
begin
  if (acol2 = 1)then begin
    s:=stringGrid2.cells[1,arow2];
    if (pos('*',s) > 0) then delete(s,pos('*',s),1)
    else s:=s+'*';
    stringGrid2.cells[1,arow2]:=s;
  end;
end;

procedure TfeffaceA.select_atom_to_del(Sender: TObject; Col, Row: Integer;
  var CanSelect: Boolean);
//-----------------------------------------------------------------------
begin
  arow2:=row;
  acol2:=col;
end;

procedure TfeffaceA.del_atom(Sender: TObject);
//--------------------------------------------
var
  atdel                : array [1..5000] of ^atomes;
  i,n                  : integer;
  s                    : string;
  w                    : word;
begin
  //Y a-il des lmements slectionns?
  n:=0;
  for i:=1 to nb_motif do begin
    s:=stringgrid2.cells[1,i];
    if (pos('*',s) = 0) then continue;
    n:=n+1;
  end;
  if (n = 0)then begin
    feffaceA.visible:=false;
    exit;
  end;

  //Message
  beep;
  s:='Are you sure to want to delete the selected atoms ?';
  w:=messageDlg(s,mtConfirmation,mbYesNoCancel,0);
  if (w = mrNo) or (w = mrAbort) then exit;

  n:=0;
  for i:=1 to nb_motif do begin
    s:=stringgrid2.cells[1,i];
    if (pos('*',s) > 0) then continue;
    n:=n+1;
    new(atdel[n]);
    atdel[n]^:=motif[i];
  end;
  for i:=1 to n do motif[i]:=atdel[i]^ ;
  for i:=1 to n do dispose(atdel[i]);
  nb_motif:=n;
  panel3.visible:=false;
  initialise(sender);
  ecrit_stringgrid2;
  feffaceA.visible:=false;
end;


end.
