procedure degrade(var num:integer);
//---------------------------------
var
  i,j,k,c,cou,c1,c2,c3,rouge,vert,bleu           : integer;
  ix1,iy1,ix2,iy2,ix,iy                          : integer;
  delta,x,y,xx,yy,dmax,dist,xk,cmax,cmin         : double;

   tabxy                                         : array[1..51] of tpoint;
   ro                                            : array[1..51] of double;
   nb_point,pas_couleur,nb_pixels                : integer;
   romax,romin,rro,pas,echr,echv,echb,sigma      : double;
   c1_dep,c2_dep,c3_dep,c1_ar,c2_ar,c3_ar        : integer;
begin
  screen.cursor:=crhourglass;
  cou:=child[num].couleur;
  c1_dep:=GetRValue(cou);
  c2_dep:=GetGValue(cou);
  c3_dep:=GetBValue(cou);
  cmax:=0;
  cmin:=256;
  if (c1_dep > cmax)then cmax:=c1_dep;
  if (c2_dep > cmax)then cmax:=c2_dep;
  if (c3_dep > cmax)then cmax:=c3_dep;
  if (c1_dep < cmin)and (c1_dep > 0) then cmin:=c1_dep;
  if (c2_dep < cmin)and (c2_dep > 0) then cmin:=c2_dep;
  if (c3_dep < cmin)and (c3_dep > 0) then cmin:=c3_dep;
  c1_ar:=255;
  c2_ar:=255;
  c3_ar:=255;

  romax:=0;
  romin:=10000;
  for i:=1 to 51 do begin
    ro[i]:=k4[num]/(k1[num]*co[i]*co[i]+k2[num]*si[i]*si[i]+k3[num]*co[i]*si[i]);
    ro[i]:=sqrt(ro[i]);
    if (ro[i] > romax)then romax:=ro[i];
    if (ro[i] < romin)then romin:=ro[i];
  end;
  nb_pixels:=round(romax*echelle);
  //nb_pixels:=round(romin*echelle);
  pas:=romax/nb_pixels;
  echr:=(c1_ar-c1_dep)/nb_pixels;
  echv:=(c2_ar-c2_dep)/nb_pixels;
  echb:=(c3_ar-c3_dep)/nb_pixels;
  sigma:=1/sqr(0.25*nb_pixels);
  with fdessin.image1.canvas do begin
    for j:=1 to nb_pixels do begin
       x:=sigma*sqr(nb_pixels-j)+1;
       rouge:=round(c1_dep+(c1_ar-c1_dep)/x);
       vert:=round(c2_dep+(c2_ar-c2_dep)/x);
       bleu:=round(c3_dep+(c3_ar-c3_dep)/x);
       c:=rgb(rouge,vert,bleu);
       pen.color:=c;
       brush.color:=c;
       for i:=1 to 51 do begin
         rro:=ro[i]-(ro[i]*(j-1))/nb_pixels;
         if (rro <= 0)then break;
         xx:=rro*co[i];
         yy:=rro*si[i];
         xx:=xx+xstk[num];
         yy:=yy+ystk[num];
         ix:=round(xx*echelle)+ixo;
         iy:=iyo-round(yy*echelle);
         tabxy[i]:=point(ix,iy);
       end;
       Polygon(tabxy);
    end;
    pen.color:=clblack;
    brush.color:=clwhite;
    for i:=1 to 51 do begin
        rro:=ro[i];
        if (rro <= 0)then break;
        xx:=rro*co[i];
        yy:=rro*si[i];
        xx:=xx+xstk[num];
        yy:=yy+ystk[num];
        ix:=round(xx*echelle+ixo);
        iy:=iyo-round(yy*echelle);
        tabxy[i]:=point(ix,iy);
    end;
    Polyline(tabxy);
  end;
  screen.cursor:=crdefault;
end;

procedure ecrit_transparent(x,y,angle: integer; var s:string);
//----------------------------------------------------------
var
  tmpF                 : HFONT;
  tmpL                 : TlogFont;
  //oldFont              : HFONT;
  tmpTFont             : TFont;
  //offsetX              : Integer;
begin
  tmpTFont:=TFont.Create;
  tmpTFont.Assign(fdessin.image1.canvas.font);
  GetObject(fdessin.image1.canvas.Font.Handle,SizeOf(TLogFont),@tmpL);
  tmpL.lfEscapement:=angle*10;
  tmpL.lfOrientation:=angle*10;
  tmpF:=CreateFontIndirect(tmpL);
  fdessin.image1.canvas.Font.Handle:=tmpF;
  setBkMode(fdessin.image1.canvas.Handle,TRANSPARENT );
  fdessin.image1.canvas.Textout(x,y,s);
  setBkMode(fdessin.image1.canvas.Handle, OPAQUE);
  fdessin.image1.canvas.Font.assign(tmpTFont);
  DeleteObject(tmpF);
  tmpTFont.Free;
end;

procedure trace_labels_bonds;
//---------------------------
var
  k,n1,n2                         : integer;
  angle,xpix,ypix                 : integer;
  s                               : string;
  xx1,yy1,xx,yy,d,xangs,yangs          : double;
begin
    if (nb_bonds = 0)then exit;
    for k:=1 to nb_bonds do begin
         if (bonds[k].width = 0)then continue;
         n1:=bonds[k].atome1;
         n2:=bonds[k].atome2;
         if (bonds[k].dx <> 0) and (bonds[k].dy <> 0) then begin
             angle:=round(bonds[k].angle);
             d:=angle/57.2957;
             s:=trim(bonds[k].labell);
             xangs:=xstk[n1]-bonds[k].dx;
             yangs:=ystk[n1]-bonds[k].dy;
             xpix:=round(xangs*echelle+(cos(d+pi/2)*fdessin.image1.canvas.textheight(s)/2))+ixo;
             ypix:=iyo-round(yangs*echelle+(sin(d+pi/2)*fdessin.image1.canvas.textheight(s)/2));
             ecrit_transparent(xpix,ypix,angle,s);
         end;
    end;
end;

procedure trace_labels_atomes;
//----------------------------
var
  i,j,i1,i2,i3,i4,ix,iy   : integer;
  s         : string;
begin
    if(fdessin.checkbox4.checked = false) and
    (fdessin.checkbox7.checked = false) then exit;
    for i:=1 to nb_child do begin
       if (child[i].tlabel = 0) or (child[i].trace = 0) then continue;
       if (abs(child[i].dx) > 0) and (abs(child[i].dy) > 0){ and
       (fdessin.checkbox7.checked = true)} then begin
         with fdessin.image1.canvas do begin
           font.name:=font_name;
           font.size:=font_size;
           font.style:=font_style;
           font.color:=font_color;
           brush.color:=coul_bkgrd;
         end;
         s:=slabel[i];
         if (fdessin.radiogroup4.ItemIndex = 1) then begin
            j:=i;
            code_positions(j,i1,i2,i3,i4);
            s:=' ('+s_pos[i1]+')('+inttostr(i1)+'_'+inttostr(i2)+
            inttostr(i3)+inttostr(i4)+')';
            s:=slabel[i]+s;
         end;
       end;
       if (abs(child[i].dx) = 0) and (abs(child[i].dy) = 0) (*and
       (fdessin.checkbox4.checked = true)*) then begin

       //end else begin
         with fdessin.image1.canvas do begin
           font.name:='Times New Roman';
           font.size:=7;
           font.style:=[];
           font.color:=clblack;
           brush.color:=child[i].couleur;
         end;
         s:=child[i].nom;
         traite_nom_atome(s);
       end;
       ix:=round((xstk[i]-child[i].dx)*echelle+ixo);
       iy:=iyo-round((ystk[i]-child[i].dy)*echelle);
       iy:=iy-(fdessin.image1.canvas.textheight(s) div 2);
       if (abs(child[i].dx) = 0) and (abs(child[i].dy) = 0){and
       (fdessin.checkbox4.checked = true) }then begin
         while (pos(' ',s) > 0)do delete(s,pos(' ',s),1);
         s:=s+'('+intToStr(i)+')';
         ix:=ix-(fdessin.image1.canvas.textwidth(s) div 2);
         ecrit_transparent(ix,iy,0,s);
       end;
       if (abs(child[i].dx) > 0) and (abs(child[i].dy) > 0) {and
       (fdessin.checkbox7.checked = true) }then ecrit_transparent(ix,iy,0,s);
    end;
end;

procedure ellipse(num,rang_tracage : integer);{
----------------------------------------------}
{num = numro de l'atome dans la liste, rang_tracage rang de traage (cote z)}
var
   i,j,k,l,ix,iy,ier,nb_coupures                : integer;
   ro,xx1,yy1,distance,delta,den                : double;
   cs,sn,x31,y31,z31,x32,y32,z32,x4,y4,z4,rho,t : double;
   vp1,vp2,vp3,xnum,p,q,r,pp,qq,rr,xx,yy,zz     : double;
   coupure                                      : array[1..500] of boolean;
   r24,r34,r43                                  : matrice3;
   s                                            : string;

   tabxy                                        : array[1..51] of tpoint;
   x,y                                          : array[1..51] of integer;
   nb_point                                     : integer;

begin
  nb_coupures:=0;
  with fdessin.image1.canvas do begin
    brush.color:=child[num].couleur;
   if (flag_couleur_fragment = 1) then begin
      brush.color:=coul_frag[child[num].nbfrg];
      child[num].couleur:=brush.color;
   end;

//Contour
    for i:=1 to 51 do begin
        ro:=k4[num]/(k1[num]*co[i]*co[i]+k2[num]*si[i]*si[i]+k3[num]*co[i]*si[i]);
        ro:=sqrt(ro);
        xx:=ro*co[i];
        yy:=ro*si[i];
        xx:=xx+xstk[num];
        yy:=yy+ystk[num];
        ix:=round(xx*echelle+ixo);
        iy:=iyo-round(yy*echelle);
        tabxy[i]:=point(ix,iy);
    end;
    Polygon(tabxy);
    if (flag_degrade = 1) then degrade(num);

//Dessin des traces de plans principaux
    if(flag_plans =1) or (flag_axes = 1) then begin
//Modif du 2 mars 2000--------(Trac des plans et axes en isotrope)------------
//    if (abs(k3[num]) < 0.1)then exit;
//-----------------------------------------------------------------------------
      for i:=1 to 3 do begin
        for j:=1 to 3 do r24[i,j]:=vecteur_propre[num,i,j];
      end;
      mat_mult(r32,r24,r34);
      matinv(r34,r43,ier);
      vp1:=1/valeur_propre[num,1];
      vp2:=1/valeur_propre[num,2];
      vp3:=1/valeur_propre[num,3];

      {Axe OZ dans le repre 4 des vecteurs propres}
      x31:=0;
      y31:=0;
      z31:=1;
      trfo(x31,y31,z31,p,q,r,r43);

      xnum:=p*p/vp1+q*q/vp2+r*r/vp3;
      pp:=2*p/vp1;
      qq:=2*q/vp2;
      rr:=2*r/vp3;

      for j:=1 to 3 do begin
        nb_point:=0;
        for i:=1 to 51 do begin
          cs:=co[i];
          sn:=si[i];
          k:=j+1;
          if (k > 3) then k:=k-3;
          rho:=sqrt(1/((cs*cs*valeur_propre[num,j])+(sn*sn*valeur_propre[num,k])));
          {premier point}
          case j of
            1:begin
                x4:=rho*cs;
                y4:=rho*sn;
                z4:=0;
              end;
            2:begin
                y4:=rho*cs;
                z4:=rho*sn;
                x4:=0;
             end;
            3:begin
                z4:=rho*cs;
                x4:=rho*sn;
                y4:=0;
             end;
          end;
          trfo(x4,y4,z4,x31,y31,z31,r34);
          xx:=x31+xstk[num];
          yy:=y31+ystk[num];
          ix:=round(xx*echelle+ixo);
          iy:=iyo-round(yy*echelle);

         {deuxime point}
//Modif du 2 mars 2000----------------------------------------------------------
         den:=(pp*x4+qq*y4+rr*z4);
         if (abs(den) < 0.00001)then continue;
//------------------------------------------------------------------------------
          t:=xnum/den;
          x4:=x4+p*t;
          y4:=y4+q*t;
          z4:=z4+r*t;
          trfo(x4,y4,z4,x32,y32,z32,r34);
          if(z31 < z32)then begin
            nb_point:=nb_point+1;
            x[nb_point]:=round(xx*echelle+ixo);
            y[nb_point]:=iyo-round(yy*echelle);
            tabxy[nb_point]:=point(ix,iy);
            continue;
          end else begin;
            if (nb_point > 0)then begin
               x[nb_point]:=round(xx*echelle+ixo);
               y[nb_point]:=iyo-round(yy*echelle);
               tabxy[nb_point]:=point(ix,iy);
               polyline(slice(tabxy,nb_point));
               nb_point:=0;
            end;
          end;
        end;
        if (nb_point > 0)then polyline(slice(tabxy,nb_point));
      end;
    end;

//Trac des axes principaux
    if(flag_axes = 1) then begin
//Modif du 2 mars 2000 (Trac des plans et axes en isotrope)-------------------
//-----------------------------------------------------------------------------
      for i:=1 to 3 do begin
        case i of
          1:begin
               x4:=1/sqrt(valeur_propre[num,1]);
               y4:=0;
               z4:=0;
            end;
          2:begin
               y4:=1/sqrt(valeur_propre[num,2]);
               z4:=0;
               x4:=0;
            end;
          3:begin
              z4:=1/sqrt(valeur_propre[num,3]);
              x4:=0;
              y4:=0;
            end;
        end;
        ix:=round(xstk[num]*echelle+ixo);
        iy:=iyo-round(ystk[num]*echelle);
        trfo(x4,y4,z4,x31,y31,z31,r34);
        moveto(ix,iy);
        if(z31 < 0)then begin
           x31:=-x31;
           y31:=-y31;
        end;
        x32:=x31+xstk[num];
        y32:=y31+ystk[num];
        ix:=round(x32*echelle+ixo);
        iy:=iyo-round(y32*echelle);
        lineto(ix,iy);
      end;
    end;

  end;
end;


