unit options;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls, ComCtrls, Grids;

type
  Tfoptions = class(TForm)
    Edit1: TEdit;
    Edit2: TEdit;
    Label7: TLabel;
    Label8: TLabel;
    BitBtn1: TBitBtn;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    Label1: TLabel;
    Label2: TLabel;
    CheckBox5: TCheckBox;
    TrackBar1: TTrackBar;
    TrackBar2: TTrackBar;
    StringGrid1: TStringGrid;
    ColorDialog1: TColorDialog;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    ListBox: TListBox;
    procedure lecture_options(Sender: TObject);
    procedure activation(Sender: TObject);
    procedure click_plans(Sender: TObject);
    procedure click_axes(Sender: TObject);
    procedure choix_couleur(Sender: TObject);
    procedure affiche_epaisseur(Sender: TObject);
    procedure affiche_angle(Sender: TObject);
    procedure peint_stringgrid1(Sender: TObject; Col, Row: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure selection_couleur(Sender: TObject; Col, Row: Integer;
      var CanSelect: Boolean);
    procedure change_probabilite(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  foptions: Tfoptions;

implementation

{$R *.DFM}

uses
  oemath,mainmenu,dessin, predessin;

procedure Tfoptions.lecture_options(Sender: TObject);
//---------------------------------------------------
var
   s                  : string;
   ier                : integer;
begin
  if (CheckBox1.state = cbchecked) then begin
    flag_plans:=1;
    CheckBox2.state:=cbunchecked;
  end else begin
    flag_plans:=-1;
  end;
  if (CheckBox2.state = cbchecked)then begin
    flag_axes:=1;
    flag_plans:=1;
    checkBox1.state:=cbunchecked;
  end else begin
    flag_axes:=-1;
  end;
  if (CheckBox3.state = cbchecked) then flag_sommets:=1 else flag_sommets:=-1;
  if (CheckBox4.state = cbchecked) then flag_labels:=1 else flag_labels:=-1;
  if (CheckBox5.state = cbchecked) then flag_degrade:=1 else flag_degrade:=-1;
  s:=edit1.text;
  val(s,epaisseur,ier);
  if (ier > 0)then begin
    erreur('Erreur de frappe!');
    edit1.setfocus;
    exit;
  end;
  s:=edit2.text;
  val(s,alfa,ier);
  if (ier > 0)then begin
    erreur('Erreur de frappe!');
    edit2.setfocus;
    exit;
  end;
  refresh;
  foptions.visible:=false;
end;

procedure Tfoptions.activation(Sender: TObject);
//----------------------------------------------
var
  s2    : string[2];
  c     : string[1];
  i,j,iy: integer;
  s     : string;
begin

  if (flag_plans = 1) then checkBox1.state:=cbchecked else
    checkBox1.state:=cbunchecked ;
  if (flag_axes = 1) then begin
    checkBox2.state:=cbchecked;
    checkBox1.state:=cbunchecked;
  end else begin
    checkBox2.state:=cbunchecked;
  end;
  if (flag_degrade =1)then checkBox5.state:=cbchecked else
    checkBox5.state:=cbunchecked;
  if (flag_sommets = 1)then checkBox3.state:=cbchecked else
    checkBox3.state:=cbunchecked;
  if (flag_labels = 1)then checkBox4.state:=cbchecked else
    checkBox4.state:=cbunchecked;
  str(epaisseur:6:2,s);
  edit1.text:=s;
  str(alfa:6:2,s);
  edit2.text:=s;

//Eciture des symboles atomiques et des couleurs dans la grille
  with foptions.stringGrid1 do begin
    rowcount:=nb_typ_element+1;
    colwidths[0]:=40;
    colwidths[1]:=20;
    for i:=1 to nb_typ_element do Cells[0,i]:=element[i].nom;
    Cells[0,0]:='Bonds';
  end;

  Listbox.ItemIndex:=probabilite-1;
end;

procedure Tfoptions.click_plans(Sender: TObject);
//-----------------------------------------------
begin
  Checkbox2.state:=cbunchecked;
end;

procedure Tfoptions.click_axes(Sender: TObject);
//---------------------------------------------
begin
  Checkbox1.state:=cbunchecked;
end;

procedure Tfoptions.choix_couleur(Sender: TObject);
//-------------------------------------------------
begin
  flag_degrade:=1;
end;

procedure Tfoptions.affiche_epaisseur(Sender: TObject);
//-----------------------------------------------------
var
   s   : string;
   x   : double;
begin
  x:=trackbar1.position*0.01;
  str(x:5:2,s);
  edit1.text:=s;
end;

procedure Tfoptions.affiche_angle(Sender: TObject);
//-------------------------------------------------
 var
   s   : string;
   x   : double;
begin
  x:=trackbar2.position*2;
  str(x:5:2,s);
  edit2.text:=s;
end;

procedure Tfoptions.peint_stringgrid1(Sender: TObject; Col, Row: Integer;
  Rect: TRect; State: TGridDrawState);
//-----------------------------------------------------------------------
var
   s   : string;
   posx: integer;
begin
   if (col = 0) then stringgrid1.canvas.brush.color:=clwhite
   else begin
     if (row = 0) then stringgrid1.canvas.brush.color:=coul_liai
     else stringgrid1.canvas.brush.color:=teinte[element[row].couleur];
   end;
   stringgrid1.canvas.fillrect(rect);
   stringgrid1.canvas.font.color:=clblack;
   s:=stringgrid1.cells[col,row];
   posx:= ((Rect.right-rect.left-2)-stringgrid1.canvas.textWidth(s)) div 2;
   stringgrid1.canvas.textrect(rect,rect.left+posx,rect.top,s);
end;

procedure Tfoptions.selection_couleur(Sender: TObject; Col, Row: Integer;
  var CanSelect: Boolean);
//------------------------------------------------------------------------
begin
 if colorDialog1.execute then begin
    if (row = 0)then coul_liai:=colorDialog1.color
    else teinte[element[row].couleur]:=colorDialog1.color;
 end ;
end;

procedure Tfoptions.change_probabilite(Sender: TObject);
//-----------------------------------------------------
begin
  probabilite:=listbox.itemIndex+1;
  diagonalise;
  dessine;
end;

end.
