unit relit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons;

type
  TForm1 = class(TForm)
    BitBtn1: TBitBtn;
    ListBox1: TListBox;
    procedure go(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}
type atomes = record
  nom          : string[4];
  x,y,z        : double;
  beta         : array[1..6] of double;
  no_element   : integer;
  couleur      : integer;
  nbfrg        : integer;
end;

type typ_liaisons = record
   atome1 : string[2];
   atome2 : string[2];
   distance : double;
end;

type liai = record
   atome1 : integer;
   atome2 : integer;
end;

type elem = record
   couleur     : integer;
   rayon       : double;
   nom         : string[2];
end;

type
  matrice3                         = array[1..3,1..3] of double ;
  vecteur3                         = array[1..3] of double;
  vecteur4                         = array[1..4] of double;
  tab_reel                         = array[1..11] of double;

const
  pir         = 57.2957;

var
  palett : array[1..15] of tcolor =
  (clred,clgray,cllime,clgreen,clteal,clyellow,claqua,clmaroon,clolive,
  clsilver, clpurple,clfuchsia,clred,clwhite,clblack);
  coul_liai,coul_bkgrd           : integer;
  nomf                           : TextFile;
  nomesp                         : textFile;

  {Noms}
  nomstruc                                : string;
  nom_fichier_shelx                       : string;
  nom_fichier_grt                         : string;
  type_fichier_shelx                      : integer;

  {Maille}
  cel,celr                                : array[1..6] of double;

  //Tableau des positions
  tp                                      : array[1..192,1..3,1..4]of double;
  s_pos                                   : array[1..192] of string[24];
  npos                                    : integer;
  tx,ty,tz                                : array[1..4] of double;
  nbtrans                                 : integer;

  {Tableau des positions slectionnes}
  tp_sel                                  : array[1..192,1..3,1..4] of double;
  npos_sel,nb_tp_sel                      : integer;
  selected                                : array[1..192] of integer;

  //Atomes du motif asymtrique
  motif                                   : array[1..1000] of atomes;
  nb_motif                                : integer;

  //Atomes gnrs
  child                                    : array[1..2000] of atomes;
  nb_child                                 : integer;
  x_arete,y_arete,z_arete                  : double;
  x_centre,y_centre,z_centre               : double;
  rayon_sphere                             : double;

  //fragments
  nb_fragments                             : integer;

  //Types d'lments
  element                                 : array[1..20] of elem;
  nb_typ_element                          : integer;

  //Type de liaisons
  tableau_liai                            : array[1..100] of typ_liaisons;
  nb_typ_liai                             : integer;

  //Liaisons tablies
  bonds                                   : array[1..20000] of liai;
  nb_bonds                                : SmallInt;

  {Matrices}
  r10,r01,r21,r12,r13,r31,r23,r32,r20,r02 : matrice3;
  r30,r03                                 : matrice3;

  //Agitation thermique
  probabilite                             : integer;

  //Diagonalisation
  vecteur_propre                           : array[1..2000,1..3,1..3] of double;
  valeur_propre                            : array[1..2000,1..3] of double;
  b_quad                                   : array[1..2000,1..3,1..3] of double;

  //flags divers integers
  flag_coupure,flag_degrade                     : integer;
  flag_sommets,flag_plans,flag_axes,flag_labels : integer;
  flag_fragment,flag_sphere,flag_boite          : boolean;
  epaisseur,alfa                                : double;


const
elements : array[1..13] of string[2] =
(       'H',   'C',   'O',    'N',   'F',    'S',   'CL',    'FE',   'CO', 'NI',
'I',       'BR', 'CU');


procedure TForm1.go(Sender: TObject);
//----------------------------------
var
  nomf                               : file;
  x                                  : double;
  i,j,k,l                            : integer;
  s,s1                               : string;
begin
//Lecture
//------------------------------------------------------------------------------
  assignFile(nomf,'bin.grt');
  reset(nomf,1);
//Maille
  for i:=1 to 6 do blockread(nomf,cel[i],8);
//Positions quivalentes
  blockread(nomf,npos,4);
  for i:=1 to npos do
  for j:=1 to 3 do
  for k :=1 to 4 do blockread(nomf,tp[i,j,k],8);
  for i:=1 to npos do blockread(nomf,s_pos[i],24);
//Translations
  blockread(nomf,nbtrans,4);
  for i:=1 to nbtrans do begin
    blockread(nomf,tx[i],8);
    blockread(nomf,ty[i],8);
    blockread(nomf,tz[i],8);
  end;
//Positions quivalentes slectionnes
  blockread(nomf,npos_sel,4);
  for i:=1 to npos_sel do
  for j:=1 to 3 do
  for k :=1 to 4 do blockread(nomf,tp_sel[i,j,k],8);
//Numero des positions slectionnes
  for i:=1 to npos do blockread(nomf,selected,4);
//Atomes du motif asymetrique
  blockread(nomf,nb_motif,4);
  for i:=1 to nb_motif do begin
    with motif[i] do begin
     blockread(nomf,nom,4);
     blockread(nomf,x,8);
     blockread(nomf,y,8);
     blockread(nomf,z,8);
     for j:=1 to 6 do blockread(nomf,beta[j],8);
     blockread(nomf,no_element,4);
     blockread(nomf,couleur,4);
     blockread(nomf,nbfrg,4);
    end;
  end;
//Atomes gnrs
  blockread(nomf,nb_child,4);
  for i:=1 to nb_child do begin
    with child[i] do begin
     blockread(nomf,nom,4);
     blockread(nomf,x,8);
     blockread(nomf,y,8);
     blockread(nomf,z,8);
     for j:=1 to 6 do blockread(nomf,beta[j],8);
     blockread(nomf,no_element,4);
     blockread(nomf,couleur,4);
     blockread(nomf,nbfrg,4);
    end;
  end;
//Cube,sphre
  blockread(nomf,x_arete,8);
  blockread(nomf,y_arete,8);
  blockread(nomf,z_arete,8);
  blockread(nomf,x_centre,8);
  blockread(nomf,y_centre,8);
  blockread(nomf,z_centre,8);
  blockread(nomf,rayon_sphere,8);
//Fragments
  blockread(nomf,nb_fragments,4);
//Types d'lments
  blockread(nomf,nb_typ_element,4);
  for i:=1 to nb_typ_element do begin
    with element[i] do begin
      blockread(nomf,couleur,4);
      blockread(nomf,rayon,8);
      blockread(nomf,nom,2);
    end;
  end;
//Types de liaisons
  blockread(nomf,nb_typ_liai,4);
  for i:=1 to nb_typ_liai do begin
    with tableau_liai[i] do begin
      blockread(nomf,atome1,2);
      blockread(nomf,atome2,2);
      blockread(nomf,distance,8);
    end;
  end;
//Liaisons tablies
  blockread(nomf,nb_bonds,4);
  for i:=1 to nb_bonds do begin
    with bonds[i] do begin
      blockread(nomf,atome1,4);
      blockread(nomf,atome2,4);
    end;
  end;
//Matrice
  for i:=1 to 3 do
  for j:=1 to 3 do blockread(nomf,r10[i,j],8);
  for i:=1 to 3 do
  for j:=1 to 3 do blockread(nomf,r01[i,j],8);
  for i:=1 to 3 do
  for j:=1 to 3 do blockread(nomf,r21[i,j],8);
  for i:=1 to 3 do
  for j:=1 to 3 do blockread(nomf,r12[i,j],8);
  for i:=1 to 3 do
  for j:=1 to 3 do blockread(nomf,r13[i,j],8);
  for i:=1 to 3 do
  for j:=1 to 3 do blockread(nomf,r31[i,j],8);
  for i:=1 to 3 do
  for j:=1 to 3 do blockread(nomf,r23[i,j],8);
  for i:=1 to 3 do
  for j:=1 to 3 do blockread(nomf,r32[i,j],8);
  for i:=1 to 3 do
  for j:=1 to 3 do blockread(nomf,r20[i,j],8);
  for i:=1 to 3 do
  for j:=1 to 3 do blockread(nomf,r02[i,j],8);
  for i:=1 to 3 do
  for j:=1 to 3 do blockread(nomf,r30[i,j],8);
  for i:=1 to 3 do
  for j:=1 to 3 do blockread(nomf,r03[i,j],8);
//Probabilit
  blockread(nomf,probabilite,4);
//Diagonalisation
  for i:=1 to nb_child do begin
    for j:=1 to 3 do
    for k:=1 to 3 do
    blockread(nomf,vecteur_propre[i,j,k],8);
    for j:=1 to 3 do
    blockread(nomf,valeur_propre[i,j],8);
    for j:=1 to 3 do
    for k:=1 to 3 do
    blockread(nomf,b_quad[i,j,k],8);
  end;
//Flags divers
  blockread(nomf,flag_coupure,4);
  blockread(nomf,flag_degrade,4);
  blockread(nomf,flag_sommets,4);
  blockread(nomf,flag_plans,4);
  blockread(nomf,flag_coupure,4);
  blockread(nomf,flag_axes,4);
  blockread(nomf,flag_labels,4);
  blockread(nomf,flag_fragment,1);
  blockread(nomf,flag_sphere,1);
  blockread(nomf,flag_boite,1);
//paramtres du trait
  blockread(nomf,epaisseur,8);
  blockread(nomf,alfa,8);
  closefile(nomf);

//Ecriture
//------------------------------------------------------------------------------
  s:='';
  for i:=1 to 6 do begin
    str(cel[i]:8:3,s1);
    s:=s+' '+s1;
  end;
  listbox1.items.add(s);
  str(npos:5,s1);
  listbox1.items.add('npos:'+s1);
  for i:=1 to npos do begin
    s:='';
    for j:=1 to 3 do begin
      for k:=1 to 4 do begin
        str(tp[i,j,k]:5:1,s1);
        s:=s+s1;
      end;
      s:=s+'   ';
    end;
    listbox1.Items.add(s);
  end;
  str(npos_sel:5,s1);
  listbox1.items.add('npos_sel:'+s1);
  for i:=1 to npos_sel do begin
    s:='';
    for j:=1 to 3 do begin
      for k:=1 to 4 do begin
        str(tp_sel[i,j,k]:5:1,s1);
        s:=s+s1;
      end;
      s:=s+'   ';
    end;
    listbox1.Items.add(s);
  end;

end;

end.
