unit wmetafile;

interface
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, printers, math, ExtCtrls, ColorBtns;

procedure Ecrit_MetaFile;

implementation

uses
  oemath;

var
  echelle                                            : single;
  ixo,iyo,l_meta                                     : integer;
  num_trace,num_atome                         : array[1..2000] of integer;
  k1,k2,k3,k4                                 : array[1..2000] of double;
  co,si                                       : array[1..101] of double;
  nb_stk,epaisseur_trait,dimension_charactere : integer;
  bb                                          : array[1..2000,1..3,1..3] of double;
  MyMetaFile                                  : TMetaFile;
  MTcan                                       : TMetaFileCanvas;

procedure inter1(i : integer;xo,yo,zo,p,q,r : double;var t1,t2 :double);
//-------------------------------------------------------------------------
//Intersection de la droite x=xo+p*t,y=yo+y*t,z=zo+r*t avec l'ellipsode no i
//Retourne t1 et t2.
var
  ax,bx,cx,delta,t         : double;
begin
    t1:=0;t2:=0;
    ax:=bb[i,1,1]*p*p+bb[i,2,2]*q*q+bb[i,3,3]*r*r+
       2*(bb[i,1,2]*p*q+bb[i,1,3]*r*p+bb[i,2,3]*q*r);
    bx:=2*(bb[i,1,1]*xo*p+bb[i,2,2]*yo*q+bb[i,3,3]*zo*r+
       bb[i,1,2]*(xo*q+yo*p)+bb[i,1,3]*(xo*r+zo*p)+bb[i,2,3]*(yo*r+zo*q));
    cx:=bb[i,1,1]*xo*xo+bb[i,2,2]*yo*yo+bb[i,3,3]*zo*zo+
       2*(bb[i,1,2]*xo*yo+bb[i,1,3]*xo*zo+bb[i,2,3]*yo*zo)-1;
    delta:=bx*bx-4*ax*cx;
    if (delta <= 0)then exit;
    delta:=sqrt(delta);
    t1:=(-bx-delta)/(2*ax);
    t2:=(-bx+delta)/(2*ax);
    if (t1 > t2) then begin
      t:=t2;
      t2:=t1;
      t1:=t;
    end;
end;

procedure inter2(i : integer; xo,yo,p,q:double; var t1,t2 :double);
//------------------------------------------------------------
//Intersection de la droite x=xo+p*t,y=yo+y*t dans le plan de projection avec le
//contour de l'ellipsode numero i.
var
  ax,bx,cx,delta ,t          : double;
begin
  t1:=0;t2:=0;
  ax:=k1[i]*p*p + k2[i]*q*q + k3[i]*p*q;
  bx:=2*k1[i]*xo*p+2*k2[i]*yo*q+k3[i]*(xo*q+yo*p);
  cx:=k1[i]*xo*xo+k2[i]*yo*yo+k3[i]*xo*yo-k4[i];
  delta:=bx*bx-4*ax*cx;
  if (delta <= 0)then exit;
  delta:=sqrt(delta);
  t1:=(-bx-delta)/(2*ax);
  t2:=(-bx+delta)/(2*ax);
  if (t1 > t2) then begin
      t:=t2;
      t2:=t1;
      t1:=t;
  end;
end;

procedure cote(i : integer; xo,yo:double; var z1,z2 :double);
//-------------------------------------------------------
//Intersection de la droite verticale passant par xo,yo, avec l'ellipsode
var
  ax,bx,cx,delta,z          : double;
begin
  z1:=0;z2:=0;
  ax:=bb[i,3,3];
  bx:=2*(bb[i,1,3]*xo+bb[i,2,3]*yo);
  cx:=bb[i,1,1]*xo*xo+bb[i,2,2]*yo*yo+2*bb[i,1,2]*xo*yo-1;
  if (ax < 1e-16)then begin
    if (bx > 1e-16)then begin
      z1:=-cx/bx;
      z2:=z1;
    end;
  end;
  delta:=bx*bx-4*ax*cx;
  if (delta < 0)then exit;
  delta:=sqrt(delta);
  z1:=(-bx-delta)/(2*ax);
  z2:=(-bx+delta)/(2*ax);
  if (z1 > z2) then begin
    z:=z2;
    z2:=z1;
    z1:=z;
  end;
end;

procedure trace2(num1,num2,n1,n2,nature:integer;p,q,r:double);
//-----------------------------------------------------------
//Trac de l'atome n1  l'atome n2 sur le trajet num1  num2
var
 i,j,k                                        : integer;
 ix,iy                                        : array[1..42] of integer;
 //coord des dbuts des traits autour de num1
 dx,dy,dz                                     : array[1..21] of double;
 //contour
 tabxy                                        : array[1..42] of tpoint;
 xo,yo,zo,x,y,z                               : double;
 d,d2,phiy,phiz                               : double;
 t1,t2,t                                      : double;
 pl,ql,rl,delta ,tg_alfa,xk                   : double;
 s2                                           : string[2];

 dist_num1_num2,dist_num1_n1,dist_num1_n2     : double;
begin
  d:=epaisseur;
  s2:=child[num1].nom;s2:=trim(s2);s2:=uppercase(s2);
  if (s2 = 'H') then d:=d/3;
  s2:=child[num2].nom;s2:=trim(s2);s2:=uppercase(s2);
  if (s2 = 'H') then d:=d/3;
  d2:=d*d;
  tg_alfa:=tan(alfa/57.2957);

  dist_num1_num2:=sqrt(p*p+q*q+r*r);
  dist_num1_n1:=sqrt(sqr(xstk[num1]-xstk[n1])+sqr(ystk[num1]-ystk[n1]));
  dist_num1_n2:=sqrt(sqr(xstk[num1]-xstk[n2])+sqr(ystk[num1]-ystk[n2]));
  delta:=dist_num1_num2*tg_alfa;

  //cood. des dbuts de trait sur num1
  for i:=1 to 21 do begin
     yo:=d-(i-1)*d/10 ;
     zo:=-sqrt(abs(d2-yo*yo));
     xo:=0;
     phiy:=arctan2(r,p);
     x:=xo*cos(phiy)+zo*sin(phiy);
     z:=-xo*sin(phiy)+zo*cos(phiy);
     y:=yo;
     phiz:=arctan2(q,p);
     dx[i]:=x*cos(phiz)-y*sin(phiz);
     dy[i]:=x*sin(phiz)+y*cos(phiz);
     dz[i]:=abs(z);
  end;

  //contour sur l'atome n1
  for i:=1 to 21 do begin
     xk:=(1-dist_num1_n1*tg_alfa);
     xo:=dx[i]*xk;
     yo:=dy[i]*xk;
     zo:=dz[i]*xk;
     //*********************
     pl:=p-delta*xo;
     ql:=q-delta*yo;
     rl:=r-delta*zo;
     //*********************
     //origine sur l'atome n1
     xo:=xo+xstk[num1]-xstk[n1];
     yo:=yo+ystk[num1]-ystk[n1];
     zo:=zo+zstk[num1]-zstk[n1];
     inter2(n1,xo,yo,pl,ql,t1,t2);
     if (t2 <> 0)then t:=t2 else  t:=-(pl*xo+ql*yo)/(pl*pl+ql*ql);

     x:=xstk[n1]+xo+pl*t;
     y:=ystk[n1]+yo+ql*t;
     ix[i]:=ixo+round(x*echelle);
     iy[i]:=iyo-round(y*echelle);
  end;

  //contour sur l'atome n2 (arrive)
  for i:=1 to 21 do begin
     xk:=(1-dist_num1_n2*tg_alfa);
     xo:=dx[i]*xk;
     yo:=dy[i]*xk;
     zo:=dz[i]*xk;

     pl:=p-delta*xo;
     ql:=q-delta*yo;
     rl:=r-delta*zo;

     //origine sur l'atome n
     xo:=xo+xstk[num1]-xstk[n2];
     yo:=yo+ystk[num1]-ystk[n2];
     zo:=zo+zstk[num1]-zstk[n2];
     inter1(n2,xo,yo,zo,pl,ql,rl,t1,t2);
     if (t1 = 0) and (t2 = 0)then inter2(n2,xo,yo,pl,ql,t1,t2);
     if (t1 <> 0)then t:=t1 else t:=-(pl*xo+ql*yo)/(pl*pl+ql*ql);

     //origine dessin
     x:=xstk[n2]+xo+pl*t;
     y:=ystk[n2]+yo+ql*t;
     ix[43-i]:=ixo+round(x*echelle);
     iy[43-i]:=iyo-round(y*echelle);
  end;

  for k:= 1 to 42 do begin
    i:=ix[k];
    j:=iy[k];
    tabxy[k]:=point(i,j);
  end;

  with MTCan do begin
    pen.width:=epaisseur_trait;
    brush.color:=coul_liai;
//    Polygon(tabxy);
(*    pen.width:=1;
    if (nature = 2) then begin
        moveto(ix[11],iy[11]);
        lineto(ix[32],iy[32]);
        moveto(ix[6],iy[6]);
        lineto(ix[36],iy[36]);
        moveto(ix[16],iy[16]);
        lineto(ix[27],iy[27]);
    end;
    if (nature = 1)then begin  //double liaison
        moveto(ix[8],iy[8]);
        lineto(ix[34],iy[34]);
        moveto(ix[14],iy[14]);
        lineto(ix[29],iy[29]);
    end; *)


    case nature of
      0:brush.color:=coul_liai;
      1:brush.color:=clgreen;
      2:brush.color:=clblue;
    end;
    Polygon(tabxy);
   (* if (nature = 1) or (nature = 3) then begin
      moveto(ix[11],iy[11]);
      lineto(ix[32],iy[32]);
    end;
    if (nature = 3)then begin
      moveto(ix[6],iy[6]);
      lineto(ix[36],iy[36]);
      moveto(ix[16],iy[16]);
      lineto(ix[27],iy[27]);
    end;
    if (nature = 2)then begin
      moveto(ix[8],iy[8]);
      lineto(ix[34],iy[34]);
      moveto(ix[14],iy[14]);
      lineto(ix[29],iy[29]);
    end;  *)
  end;

end;

procedure liaisonpr(n1,n2,nature  : integer);
//-------------------------------------------
//trace une liaison entre l'atome 1 et l'atome 2
type coupure = record
  t                                     : double;
  no_t,ind                              : integer;
end;

var
 num1,num2                                    : integer;
 x1,y1,z1,x2,y2,z2,x,y,z                      : double;
 xo1,yo1,zo1,xo2,yo2,zo2                      : double;

 i,j,k,n,m                                    : integer;

 //coupures
 p,q,r,t1,t2,tt1,tt2,tau1,tau2,tmin,tmax      : double;
 nb_t                                         : integer;
 coup                                         : array[1..50] of coupure;
 dum                                          : coupure;

 //Contour
 flag_contour                                 : integer;

 zz1,zz2                                      : double;

begin
    for i:=1 to 50 do begin
      coup[i].ind:=0;
      coup[i].no_t:=0;
      coup[i].t:=0;
    end;

    //Lequel des 2 atomes est-il dessus?
    if (zstk[n1] >= zstk[n2])then begin
      num1:=n1;
      num2:=n2;
    end else begin
      num1:=n2;
      num2:=n1;
    end;
    x1:=xstk[num1];    y1:=ystk[num1];    z1:=zstk[num1];
    x2:=xstk[num2];    y2:=ystk[num2];    z2:=zstk[num2];
    p:=x2-x1;          q:=y2-y1;          r:=z2-z1;
    xo1:=0;            yo1:=0;            zo1:=0;

    //Atome de dpart
    x:=0;
    y:=0;
    inter2(num1,x,y,p,q,t1,t2);
    tmin:=t2;

    //atome d'arrive
    x:=x1-xstk[num2];
    y:=y1-ystk[num2];
    z:=z1-zstk[num2];
    inter1(num2,x,y,z,p,q,r,tt1,tt2);
    tmax:=tt1;
    if (tmin >tmax)then exit;      //recouvrement

    nb_t:=0;
    for i:=1 to nb_child do begin
        x:=x1-xstk[i];
        y:=y1-ystk[i];

        //Coupure du contour
        inter2(i,x,y,p,q,t1,t2);
        if (t1 = 0) and (t2 = 0)then continue;              // Pas de coupure

        // Recouvrement?
        if (i <> num1) and (i <> num2)then begin
            if (t1 < tmin) and (t2 > tmax)then exit;
        end;
        tau1:=t1;
        tau2:=t2;

        //Coupure de l'ellipsode
        x:=x1-xstk[i];
        y:=y1-ystk[i];
        z:=z1-zstk[i];
        inter1(i,x,y,z,p,q,r,tt1,tt2);

        //Le contour coup est-il au dessous de la droite?
        if (tt1 = 0) and (tt2 = 0)then begin
          x:=x1+t2*p-xstk[i];
          y:=y1+t2*q-ystk[i];
          z:=z1+t2*r-zstk[i];
          cote(i,x,y,zz1,zz2);
          if ( zz2 < z )then continue;
        end;
        if (tt2 <> 0)then tau2:=tt2;

        if (tau1 > 1) or  (tau2 < 0)then continue;            // Coup en dehors
        //sortie
        if (tau1 > 0) and (tau1 < 1)then begin
          nb_t:=nb_t+1;
          coup[nb_t].t:=tau1;
          coup[nb_t].no_t:=i;
          coup[nb_t].ind:=2;
        end;
        //entre
        if (tau2 > 0) and (tau2 < 1)then begin
          nb_t:=nb_t+1;
          coup[nb_t].t:=tau2;
          coup[nb_t].no_t:=i;
          coup[nb_t].ind:=1;
        end;
    end;

    //Rangement
    for i:=1 to nb_t-1 do begin
        for j:=i+1 to nb_t do begin
          if (coup[i].t > coup[j].t) then begin
            dum:=coup[i];
            coup[i]:=coup[j];
            coup[j]:=dum;
          end;
        end;
    end;

    //Trac
    i:=1;
    while(i < nb_t)do begin
        if (coup[i].ind = 1) and (coup[i+1].ind = 2)then begin
          j:=coup[i].no_t;
          k:=coup[i+1].no_t;
          trace2(num1,num2,coup[i].no_t,coup[i+1].no_t,nature,p,q,r);
        end;
        i:=i+1;
    end;
end;

procedure degrade(var num:integer);
//---------------------------------
var
  i,j,k,c,cou,c1,c2,c3,rouge,vert,bleu       : integer;
  ix1,iy1,ix2,iy2,ix,iy                     : integer;
  delta,x,y,xx,yy,dmax,dist,xk,cmax,cmin         : double;

   tabxy                                        : array[1..101] of tpoint;
   ro                                           : array[1..101] of double;
   nb_point,pas_couleur,nb_pixels               : integer;
   romax,romin,rro,pas,echr,echv,echb,sigma                                : double;
   c1_dep,c2_dep,c3_dep,c1_ar,c2_ar,c3_ar       : integer;
begin
  screen.cursor:=crhourglass;
  cou:=child[num].couleur;
  c1_dep:=GetRValue(cou);
  c2_dep:=GetGValue(cou);
  c3_dep:=GetBValue(cou);
  cmax:=0;
  cmin:=256;
  if (c1_dep > cmax)then cmax:=c1_dep;
  if (c2_dep > cmax)then cmax:=c2_dep;
  if (c3_dep > cmax)then cmax:=c3_dep;
  if (c1_dep < cmin)and (c1_dep > 0) then cmin:=c1_dep;
  if (c2_dep < cmin)and (c2_dep > 0) then cmin:=c2_dep;
  if (c3_dep < cmin)and (c3_dep > 0) then cmin:=c3_dep;
  c1_ar:=255;
  c2_ar:=255;
  c3_ar:=255;

  romax:=0;
  romin:=10000;
  for i:=1 to 101 do begin
    ro[i]:=k4[num]/(k1[num]*co[i]*co[i]+k2[num]*si[i]*si[i]+k3[num]*co[i]*si[i]);
    ro[i]:=sqrt(ro[i]);
    if (ro[i] > romax)then romax:=ro[i];
    if (ro[i] < romin)then romin:=ro[i];
  end;
  nb_pixels:=round(romax*echelle);
  //nb_pixels:=round(romin*echelle);
  pas:=romax/nb_pixels;
  echr:=(c1_ar-c1_dep)/nb_pixels;
  echv:=(c2_ar-c2_dep)/nb_pixels;
  echb:=(c3_ar-c3_dep)/nb_pixels;
  sigma:=1/sqr(0.25*nb_pixels);
  with MTCan do begin
    for j:=1 to nb_pixels do begin
       x:=sigma*sqr(nb_pixels-j)+1;
       rouge:=round(c1_dep+(c1_ar-c1_dep)/x);
       vert:=round(c2_dep+(c2_ar-c2_dep)/x);
       bleu:=round(c3_dep+(c3_ar-c3_dep)/x);
       c:=rgb(rouge,vert,bleu);
       pen.color:=c;
       brush.color:=c;
       for i:=1 to 101 do begin
         rro:=ro[i]-(ro[i]*(j-1))/nb_pixels;
         if (rro <= 0)then break;
         xx:=rro*co[i];
         yy:=rro*si[i];
         xx:=xx+xstk[num];
         yy:=yy+ystk[num];
         ix:=round(xx*echelle)+ixo;
         iy:=iyo-round(yy*echelle);
         //pixels[ix,iy]:=c;
         tabxy[i]:=point(ix,iy);
       end;
       Polygon(tabxy);
    end;
    pen.color:=clblack;
    brush.color:=clwhite;
    for i:=1 to 101 do begin
        rro:=ro[i];
        if (rro <= 0)then break;
        xx:=rro*co[i];
        yy:=rro*si[i];
        xx:=xx+xstk[num];
        yy:=yy+ystk[num];
        ix:=round(xx*echelle+ixo);
        iy:=iyo-round(yy*echelle);
        tabxy[i]:=point(ix,iy);
    end;
    Polyline(tabxy);
  end;
  screen.cursor:=crdefault;
end;

procedure ecrit_transparent(var x,y: integer; var s:string);
//----------------------------------------------------------
var
  tmpF                 : HFONT;
  tmpL                 : TlogFont;
  oldFont              : HFONT;
  tmpTFont             : TFont;
  offsetX              : Integer;
begin
  tmpTFont:=TFont.Create;
  tmpTFont.Assign(MTCan.font);
  GetObject(MTCan.Font.Handle,SizeOf(TLogFont),@tmpL);
  //tmpL.lfEscapement:=900;
  //tmpL.lfOrientation:=900;
  tmpF:=CreateFontIndirect(tmpL);
  MTCan.Font.Handle:=tmpF;
  setBkMode(MTCan.Handle,TRANSPARENT );
  MTCan.Textout(x,y,s);
  setBkMode(MTCan.Handle, OPAQUE);
  MTCan.Font.assign(tmpTFont);
  DeleteObject(tmpF);
  tmpTFont.Free;
end;

procedure ellipsepr(num,rang_tracage : integer);{
------------------------------------------------}
{num = numro de l'atome dans la liste, rang_tracage rang de traage (cote z)}
var
   i,j,k,l,ix,iy,ier,nb_coupures                : integer;
   xx1,yy1,distance,delta,romax,pas,rro         : double;

   cs,sn,x31,y31,z31,x32,y32,z32,x4,y4,z4,rho,t : double;
   vp1,vp2,vp3,xnum,p,q,r,pp,qq,rr,xx,yy,zz,den : double;
   coupure                                      : array[1..2000] of boolean;
   r24,r34,r43                                  : matrice3;
   s                                            : string;

   tabxy                                        : array[1..101] of tpoint;
   x,y                                          : array[1..101] of integer;
   nb_point,pas_couleur                         : integer;
   c,cc,c1,c2,c3,cmax,rouge,vert,bleu           : integer;
begin
  nb_coupures:=0;
  with MTCan do begin
     brush.color:=child[num].couleur;
     pen.width:=epaisseur_trait;
     //pen.width:=1;
//Contour et couleur
    for i:=1 to 101 do begin
        rro:=k4[num]/(k1[num]*co[i]*co[i]+k2[num]*si[i]*si[i]+k3[num]*co[i]*si[i]);
        rro:=sqrt(rro);
        xx:=rro*co[i];
        yy:=rro*si[i];
        xx:=xx+xstk[num];
        yy:=yy+ystk[num];
        ix:=round(xx*echelle+ixo);
        iy:=iyo-round(yy*echelle);
        tabxy[i]:=point(ix,iy);
        if (i = 1)then moveto(ix,iy) else lineto(ix,iy);
    end;
    Polygon(tabxy);
    if (flag_degrade = 1) then degrade(num);

//Dessin des traces de plans principaux}
    pen.color:=clblack;
    if(flag_plans =1) or (flag_axes = 1)  then begin
      for i:=1 to 3 do begin
        for j:=1 to 3 do r24[i,j]:=vecteur_propre[num,i,j];
      end;
      mat_mult(r32,r24,r34);
      matinv(r34,r43,ier);
      vp1:=1/valeur_propre[num,1];
      vp2:=1/valeur_propre[num,2];
      vp3:=1/valeur_propre[num,3];

      {Axe OZ dans le repre 4 des vecteurs propres}
      x31:=0;
      y31:=0;
      z31:=1;
      trfo(x31,y31,z31,p,q,r,r43);

      xnum:=p*p/vp1+q*q/vp2+r*r/vp3;
      pp:=2*p/vp1;
      qq:=2*q/vp2;
      rr:=2*r/vp3;

      for j:=1 to 3 do begin
        nb_point:=0;
        for i:=1 to 101 do begin
          cs:=co[i];
          sn:=si[i];
          k:=j+1;
          if (k > 3) then k:=k-3;
          rho:=sqrt(1/((cs*cs*valeur_propre[num,j])+(sn*sn*valeur_propre[num,k])));
          {premier point}
          case j of
            1:begin
                x4:=rho*cs;
                y4:=rho*sn;
                z4:=0;
              end;
            2:begin
                y4:=rho*cs;
                z4:=rho*sn;
                x4:=0;
             end;
            3:begin
                z4:=rho*cs;
                x4:=rho*sn;
                y4:=0;
             end;
          end;
          trfo(x4,y4,z4,x31,y31,z31,r34);
          xx:=x31+xstk[num];
          yy:=y31+ystk[num];
          ix:=round(xx*echelle+ixo);
          iy:=iyo-round(yy*echelle);

         {deuxime point}
//Modif du 2 mars 2000----------------------------------------------------------
         den:=(pp*x4+qq*y4+rr*z4);
         if (abs(den) < 0.00001)then continue;
//------------------------------------------------------------------------------
          t:=xnum/den;
//        t:=xnum/(pp*x4+qq*y4+rr*z4);
          x4:=x4+p*t;
          y4:=y4+q*t;
          z4:=z4+r*t;
          trfo(x4,y4,z4,x32,y32,z32,r34);
          if(z31 < z32)then begin
            nb_point:=nb_point+1;
            x[nb_point]:=round(xx*echelle+ixo);
            y[nb_point]:=iyo-round(yy*echelle);
            tabxy[nb_point]:=point(ix,iy);
            continue;
          end else begin;
            if (nb_point > 0)then begin
               x[nb_point]:=round(xx*echelle+ixo);
               y[nb_point]:=iyo-round(yy*echelle);
               tabxy[nb_point]:=point(ix,iy);
               polyline(slice(tabxy,nb_point));
               nb_point:=0;
            end;
          end;
        end;
        if (nb_point > 0)then polyline(slice(tabxy,nb_point));
      end;
    end;

//Trac des axes principaux
    if(flag_axes = 1) then begin
      //if (child[num].beta[4] = 0)then exit;
//    if (abs(k3[num]) < 0.1)then exit;
      for i:=1 to 3 do begin
        case i of
          1:begin
               x4:=1/sqrt(valeur_propre[num,1]);
               y4:=0;
               z4:=0;
            end;
          2:begin
               y4:=1/sqrt(valeur_propre[num,2]);
               z4:=0;
               x4:=0;
            end;
          3:begin
              z4:=1/sqrt(valeur_propre[num,3]);
              x4:=0;
              y4:=0;
            end;
        end;
        ix:=round(xstk[num]*echelle+ixo);
        iy:=iyo-round(ystk[num]*echelle);
        trfo(x4,y4,z4,x31,y31,z31,r34);
        moveto(ix,iy);
        if(z31 < 0)then begin
           x31:=-x31;
           y31:=-y31;
        end;
        x32:=x31+xstk[num];
        y32:=y31+ystk[num];
        ix:=round(x32*echelle+ixo);
        iy:=iyo-round(y32*echelle);
        lineto(ix,iy);
      end;
    end;

//Trac des labels
      s:=child[num].nom;
      if ((flag_label_centre =1) or (flag_label_shift = 1)) {and
      (copy(s,1,2) <> 'H ')} then begin
        font.name:=font_name;
        font.style:=font_style;
        font.size:=font_size;
        font.color:=font_color;
        if (abs(child[num].dx) > 0) and (abs(child[num].dy) > 0) then begin
          brush.color:=coul_bkgrd;
        end else begin
          font.size:=8;
          font.name:='Times New Roman';
          font.style:=[];
          brush.color:=child[num].couleur;
        end;
        ix:=round((xstk[num]-child[num].dx)*echelle+ixo);
        iy:=iyo-round((ystk[num]-child[num].dy)*echelle);
        traite_nom_atome(s);
        iy:=iy-(textheight(s) div 2);
        if (abs(child[num].dx) = 0) and (abs(child[num].dy) = 0) then begin
          if (flag_label_shift = 0)then begin
            while (pos(' ',s) > 0)do delete(s,pos(' ',s),1);
            ix:=ix-(textwidth(s) div 2);
            ecrit_transparent(ix,iy,s);
          end;
        end else  ecrit_transparent(ix,iy,s);
      end;

    pen.width:=1;
  end;

end;

procedure Ecrit_MetaFile;
//-----------------------
var
  ix,iy,i,j,k,n1,n2                                       : integer;
  indic                                                   : array[1..2000] of integer;
  ix_s,iy_s                                               : array[1..8] of integer;
  x,y,z,xmin,ymin,zmin,xmax,ymax,zmax,xx,yy,xog,yog,zog   :double;
  s,s1                                                    : string;
   bb2,bb3,aux             : matrice3;
   iat                     : integer;
   pas,arg                 : double;
   s2                      : string[2];
   c                       : string[1];
   nomf                    : TextFile;
  myrectangle  : trect;

const x_som : array[1..8] of double = (0,1,1,0,0,1,1,0);
      y_som : array[1..8] of double = (0,0,1,1,0,0,1,1);
      z_som : array[1..8] of double = (0,0,0,0,1,1,1,1);
const
      n1_som: array[1..12] of integer = (1,2,3,4,1,2,3,4,5,6,7,8);
      n2_som: array[1..12] of integer = (2,3,4,1,5,6,7,8,6,7,8,5);
begin
   //l_meta:=screen.height;
   pas:=2*pi/100;
   for i:=1 to 101 do begin
     arg:=pas*(i-1);
     co[i]:=cos(arg);
     si[i]:=sin(arg);
   end;

//Set des coefficients du contour dans l'espace 3
   for iat:=1 to nb_child do begin
     for i:=1 to 3 do begin
       for j:=1 to 3 do bb2[i,j]:=b_quad[iat,i,j];
     end;
     mat_mult(bb2,r23,aux);
     mat_mult(r32,aux,bb3); {r31.bb2.r13}
     k1[iat]:=bb3[1,3]*bb3[1,3]-bb3[1,1]*bb3[3,3];
     k2[iat]:=bb3[2,3]*bb3[2,3]-bb3[2,2]*bb3[3,3];
     k3[iat]:=2*(bb3[1,3]*bb3[2,3]-bb3[1,2]*bb3[3,3]);
     k4[iat]:=-bb3[3,3];
     //Mise en rserve de la matrice B dans le repre 3 (pour quation ellipse)
     for i:=1 to 3 do begin
       for j:=1 to 3 do bb[iat,i,j]:=bb3[i,j];
     end;
   end;

//Set des tableaux STK (coord. dans le repre 3)
   nb_stk:=nb_child;
   for i:=1 to nb_stk do begin
     xstk[i]:=child[i].x;
     ystk[i]:=child[i].y;
     zstk[i]:=child[i].z;
     trfo2(xstk[i],ystk[i],zstk[i],r30);
   end;
   if(flag_sommets = 1) then begin
     for i:=1 to 8 do begin
       nb_stk:=nb_stk+1;
       xstk[nb_stk]:=x_som[i];
       ystk[nb_stk]:=y_som[i];
       zstk[nb_stk]:=z_som[i];
       trfo2(xstk[nb_stk],ystk[nb_stk],zstk[nb_stk],r30);
     end;
   end;

//Maxi et Mini
   xmax:=-100000.;
   ymax:=xmax;
   zmax:=xmax;
   xmin:=100000.;
   ymin:=xmin;
   zmin:=xmin;
   for i:=1 to nb_stk do begin
     if(child[i].trace = 1)then begin
       if(xstk[i] > xmax) then xmax:=xstk[i];
       if(xstk[i] < xmin) then xmin:=xstk[i];
       if(ystk[i] > ymax) then ymax:=ystk[i];
       if(ystk[i] < ymin) then ymin:=ystk[i];
       if(zstk[i] > zmax) then zmax:=zstk[i];
       if(zstk[i] < zmin) then zmin:=zstk[i];
     end;
   end;

//Recentrage
   xog:=(xmin+xmax)/2;
   yog:=(ymin+ymax)/2;
   zog:=(zmin+zmax)/2;
   for i:=1 to nb_stk do begin
     xstk[i]:=xstk[i]-xog;
     ystk[i]:=ystk[i]-yog;
     zstk[i]:=zstk[i]-zog;
   end;

//dtermination de l'chelle
   xx:=0.0001;
   for i:=1 to nb_stk do begin
     if(child[i].trace = 1)then begin
       yy:=sqr(xstk[i])+sqr(ystk[i])+sqr(zstk[i]);
       if(yy > xx) then xx:=yy;
     end;
   end;
   xx:=sqrt(xx);

//Classement des atomes en z croissant
   zmax:=-10000;
   for i:=1 to nb_child do indic[i]:=1;
   for i:=1 to nb_child do begin
     for j:=1 to nb_child do begin
       if (zstk[j] > zmax) and (indic[j] = 1) then begin
         zmax:= zstk[j];
         num_trace[i]:=i;
         num_atome[i]:=j;
       end;
     end;
     indic[num_atome[i]]:=0;
     zmax:=-10000;
   end;

//Trac MetaFile
   //assignFile(nomf,'metaf.txt');
   //rewrite(nomf);
   screen.cursor:=crHourGlass;
   MyMetaFile:=TMetaFile.Create;
   with MyMetaFile do begin
       l_meta:=2000;
       Height:=l_meta;
       Width:=l_meta;
       //MMHeight:=5000;
       //MMWidth:=5000;
       enhanced:=true;
       //inch:=500;
       //writeln(nomf,'H=',height:5,' W=',width:5,' MMH=',MMheight:5,' MMW=',MMwidth:5);
       //writeln(nomf,'Inch=',inch:5,'  Enhanced=',enhanced);
       //writeln(nomf,description);
   end;
   ixo:=l_meta div 2;
   iyo:=ixo;
   echelle:=0.9*ixo/xx;
   MTCan:=TMetaFileCanvas.create(MyMetaFile,0);
   With MTCan do
     Try
       //cliprect(0,0,5000,5000);
       pen.color:=clblack;
       epaisseur_trait:=2;
       brush.color:=coul_bkgrd;
       font.name:=font_name;
       font.size:=font_size;
       font.color:=font_color;
       font.style:=font_style;
       ix:=ixo div 2;
       iy:=iyo div 2;
       rectangle(1,1,2*ixo-1,2*ixo-1);
       pen.color:=clblack;
       //closefile(nomf);

//Trac des ellipses et des liaisons
       for j:=1 to nb_child do begin
         i:=num_atome[nb_child-j+1];
         if (child[i].trace = 1)then begin
           ellipsepr(i,j);
           if (nb_bonds > 0)then begin
             for k:=1 to nb_bonds do begin
               n1:=bonds[k].atome1;
               n2:=bonds[k].atome2;
               if (child[n1].trace = 0) or (child[n2].trace = 0)then continue;
               if (n1 = i) or (n2 = i) then liaisonpr(n1,n2,bonds[k].nature);
             end;
           end;
         end;
       end;

       if (nb_stk > nb_child)then begin
         for i:=1 to 8 do begin
           ix_s[i]:=round(xstk[nb_child+i]*echelle+ixo);
           iy_s[i]:=iyo-round(ystk[nb_child+i]*echelle);
         end;
         font.size:=10;
         brush.color:=clwhite;
         for i:=1 to 4 do begin
           moveto(ix_s[i],iy_s[i]);
           j:= i+1 ;
           if (j > 4) then j:=j-4;
           lineto(ix_s[j],iy_s[j]);
         end;
         for i:=1 to 4 do begin
           moveto(ix_s[i+4],iy_s[i+4]);
           j:= 4+i+1;
           if (j > 8)then j:=j-4;
           lineto(ix_s[j],iy_s[j]);
         end;
         for i:=1 to 4 do begin
           moveto(ix_s[i],iy_s[i]);
          lineto(ix_s[i+4],iy_s[i+4]);
         end;
//Ecriture des noms des axes du repre
         brush.color:=coul_bkgrd;
         textout(ix_s[1],iy_s[1],'o');
         textout(ix_s[2],iy_s[2],'a');
         textout(ix_s[4],iy_s[4],'b');
         textout(ix_s[5],iy_s[5],'c');
       end;
     finally
       free;
     end;
  (*Printer.BeginDoc ;
    MyRectangle.Left  := 0 ;
    MyRectangle.Right := {Printer.PageWidth }Printer.PageWidth div 2 ;
    MyRectangle.Top   := 0 ;
    MyRectangle.Bottom:={ Printer.PageHeight} Printer.PageHeight div 3 ;
    MTCan.Draw( Printer.canvas,myrectangle ) ;
  Printer.EndDoc ; *)
   MyMetaFile.savetofile(nom_fichier_wmf);
   screen.cursor:=crDefault;
end;

end.
end.
